/***************************************************************************
 *   Copyright Brian Ledbetter 2001-2003 <brian@shadowcom.net>             *
 *   Copyright Ravikiran Rajagopal 2003                                    *
 *   ravi@ee.eng.ohio-state.edu                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License (version 2) as   *
 *   published by the Free Software Foundation. (The original KSplash/ML   *
 *   codebase (upto version 0.95.3) is BSD-licensed.)                      *
 *                                                                         *
 ***************************************************************************/
/* $Id: thememacclassic.h,v 1.3 2003/03/28 16:37:43 mlaurent Exp $ */

#ifndef __THEMEMACCLASSIC_H__
#define __THEMEMACCLASSIC_H__

#include <kprogress.h>
#include <ksplash/themeengine.h>

#include <qcheckbox.h>
#include <qlabel.h>
#include <qpushbutton.h>

#include "icon.h"

class QLabel;

class MacClassicConfig: public ThemeEngineConfig
{
  Q_OBJECT
public:
  MacClassicConfig( QWidget *, KConfig * );

private slots:
  void _slotShowIconsChanged( bool );
  void _slotIconsJumpingChanged( bool );

protected:
  void _readSettings();

  QCheckBox *mShowIcons, *mIconsJumping;
  QLabel *mPreview;
  QPtrList<QPushButton> mPosButtons;

  QPtrList<QPixmap> mPreviewImages;
};

/*
 * class ThemeMacClassic: Behave in a manner similar to Mac Classic (<OS9)
 * systems.
 */
class ThemeMacClassic: public ThemeEngine
{
  Q_OBJECT
public:
  ThemeMacClassic( QWidget *, const char *, const QStringList& );

  static QStringList names()
  {
    QStringList Names;
    Names << "MacClassic";
    Names << "MacKlassic";
    Names << "Mac Classic";
    Names << "Mac Klassic";
    Names << "Macintosh";
    return( Names );
  };

public slots:
  inline void slotUpdateProgress( int i )
  {
    mProgressBar->setProgress( i );
  }
  inline void slotUpdateSteps( int i )
  {
    mProgressBar->setTotalSteps( i );
  }
  void slotSetPixmap( const QString& );

protected:
  void _initUi();
  void _readSettings();
  void _loadSplashScreen();

private:
  QPixmap mSplashScreen;
  KProgress *mProgressBar;

  Icon *mIcon, *mPrevIcon;

  int mIconCount,
  mStatusBarHeight,
  mStdIconWidth;

  Icon::Position mIconPos;
  bool mIconsJumping;
  bool mIconsVisible;
  QString mSplashScreenName;
};

#endif
