/***************************************************************************
 *   Copyright Brian Ledbetter 2001-2003 <brian@shadowcom.net>             *
 *   Copyright Ravikiran Rajagopal 2003                                    *
 *   ravi@ee.eng.ohio-state.edu                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License (version 2) as   *
 *   published by the Free Software Foundation. (The original KSplash/ML   *
 *   codebase (upto version 0.95.3) is BSD-licensed.)                      *
 *                                                                         *
 ***************************************************************************/

#ifndef  __ICON_H__
#define  __ICON_H__
#include <qlabel.h>
#include <qwidget.h>
#include <kpixmap.h>
#include <kdialogbase.h>

/*
 * class Icon: This will draw an Icon on the screen, and will zoom based on what its
 * position relative to the center is.  It will also bounce when instructed to.
 */
class  Icon: public QLabel
{
  Q_OBJECT
public:
  Icon( const QPixmap&, unsigned int, unsigned int, bool );
  ~Icon();

signals:
  void sizeChanged();

private slots:
  void incrementalShow();

private:
  void scalePixmapsForCache();

protected:
  void showEvent( QShowEvent * );
  void resizeEvent( QResizeEvent * );

  QList<QPixmap> mIcons;  // Icons sized 16 to 64 pixels.

  QPixmap mIcon;
  unsigned int mMinSize, mMaxSize;
  bool mOptimize;

  unsigned int  mSize;
  bool mInitialized;
};

#endif
